package com.smart.gtstrvl;

import com.example.mountaintravel.base.BaseActivity;
import com.example.mountaintravel.util.ToastUtil;
import com.example.mountaintravel.variable.Variable;
import com.example.mountaintravel.view.LoadingView;

import android.net.ConnectivityManager;
import android.net.NetworkInfo.State;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.RelativeLayout.LayoutParams;

public class AboutActivity extends BaseActivity implements OnClickListener {
	private WebView about_webview;
	private static final String TAG = "AboutActivity";
	private String url = "";
	private RelativeLayout about_relative;
	private LoadingView about_loadingview;
	private SharedPreferences sp;
	LinearLayout about_layout;
	private boolean flag = true;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_about);
		initTitleBar("关于");

		sp = getSharedPreferences("variable", Context.MODE_PRIVATE);
		about_webview = (WebView) findViewById(R.id.about_webview);
		about_layout = (LinearLayout) findViewById(R.id.about_layout);
		addview();
		WebSettings wSet = about_webview.getSettings();
		wSet.setJavaScriptEnabled(true);
		about_webview.getSettings().setDomStorageEnabled(false);
		about_webview.getSettings().setAppCacheEnabled(false);
		url = "http://" + Variable.address + "/terminal/about";
		// 设置 Application Caches 缓存目录
		about_webview.setWebViewClient(new WebViewClient() {
			@Override
			public boolean shouldOverrideUrlLoading(WebView view, String url) {
				
				about_loadingview.start();
				view.loadUrl(url);

				return true;
			}
			@Override
			public void onReceivedError(WebView view, int errorCode,
					String description, String failingUrl) {
				// TODO Auto-generated method stub
				super.onReceivedError(view, errorCode, description, failingUrl);
				ConnectivityManager cwjManager = (ConnectivityManager) getSystemService(AboutActivity.this.CONNECTIVITY_SERVICE);
				State mobile = cwjManager.getNetworkInfo(
						ConnectivityManager.TYPE_MOBILE).getState();
				State wifi = cwjManager.getNetworkInfo(ConnectivityManager.TYPE_WIFI)
						.getState();
				if (!(mobile == State.CONNECTED || mobile == State.CONNECTING
						|| wifi == State.CONNECTED || wifi == State.CONNECTING)) {
					ToastUtil.show(AboutActivity.this, "网络异常，请检查网络");
				} 
				flag=false;
				view.loadUrl("file:///android_asset/loading.html");

			}
			@Override
			public void onPageFinished(WebView view, String url) {
				// TODO Auto-generated method stub
				flag=false;
				about_loadingview.stop();
				about_webview.setVisibility(View.VISIBLE);
				about_relative.setVisibility(View.GONE);
				super.onPageFinished(view, url);
			}
			@Override
			public void onPageStarted(WebView view, String url, Bitmap favicon) {
				// TODO Auto-generated method stub
				flag=true;
				new Thread() {
					@Override
					public void run() {
						// super.run();
						int i = 0;
						while (flag) {
							i++;
							Log.d(TAG, i+"");
							try {
								Thread.sleep(1000);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							if (i > 60) {
								runOnUiThread( new Runnable() {
									public void run() {
										about_webview.loadUrl("file:///android_asset/loading.html");
										flag = false;
									}
								});
								
							}

						}
					}

				}.start();
				about_relative.setVisibility(View.VISIBLE);
				about_webview.setVisibility(View.GONE);
				super.onPageStarted(view, url, favicon);
				Log.d(TAG, url);
			}

		});

		
		about_webview.loadUrl(url);
	}

	@SuppressLint("NewApi")
	public void addview() {
		WindowManager manager = (WindowManager) getSystemService(Context.WINDOW_SERVICE);
		Display display = manager.getDefaultDisplay();
		DisplayMetrics outMetrics = new DisplayMetrics();
		display.getRealMetrics(outMetrics);

		about_relative = (RelativeLayout) findViewById(R.id.about_relative);
		about_loadingview = new LoadingView(getBaseContext(),
				outMetrics.widthPixels);
		RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(
				LayoutParams.MATCH_PARENT, 6);
		// lp.addRule(RelativeLayout.ALIGN_BASELINE);
		about_relative.setOnClickListener(this);
		// lp.addRule(RelativeLayout.CENTER_HORIZONTAL, RelativeLayout.TRUE);
		about_relative.addView(about_loadingview, lp);

	}

	public void onResume() {
		// TODO Auto-generated method stub
		about_loadingview.start();
		super.onResume();
	}

	@Override
	public void onPause() {
		// TODO Auto-generated method stub
		about_loadingview.stop();
		super.onPause();
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub

	}

	@SuppressLint("NewApi")
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		flag=false;
		if (about_webview != null) {
			about_layout.removeView(about_webview);
			about_webview.removeAllViews();
			about_webview.onPause();
			about_webview.destroy();
		}
	}

}
